#include "role.h"

#include "util.h"

void vdsm_role_clear(VDSMRole *role) {
    role->collectable = false;
    role->collecting = false;
    role->master = false;
    role->auxiliary = false;
    role->noauto = false;
    role->restricted = false;
}

bool vdsm_role_validate(VDSMRole *role) {
    if (role->collectable && role->collecting) {
        vdsm_report(LOG_ERR, "Incompatible roles: collectable and collecting\n");
        return false;
    }
    if (role->master && !role->collecting) {
        vdsm_report(LOG_ERR, "Missing role: A master vdsm must also be collecting\n");
        return false;
    }
    if (role->noauto && !role->collectable) {
        vdsm_report(LOG_ERR, "Missing role: A noauto vdsm must also be collectable\n");
        return false;
    }
    if (role->restricted && !role->collecting) {
        vdsm_report(LOG_ERR, "Missing role: A restricted vdsm must also be collecting\n");
        return false;
    }
    return true;
}

bool vdsm_role_needs_announcement(VDSMRole* role) {
    return (role->collectable || role->collecting);
}
